searchNodes=[{"doc":"Generates migrations, and stores a snapshot of your resources.Options:apis - a comma separated list of API modules, for which migrations will be generatedsnapshot_path - a custom path to store the snapshots, defaults to &quot;priv/resource_snapshots&quot;migration_path - a custom path to store the migrations, defaults to &quot;priv&quot;. Migrations are stored in a folder for each repo, so priv/repo_name/migrationsFlags:quiet - messages for file creations will not be printedno_format - files that are created will not be formatted with the code formatterdry_run - no files are created, instead the new migration is printedConflicts/Multiple ResourcesThe migration generator can support multiple schemas using the same table. It will raise on conflicts that it can't resolve, like the same field with different types. It will prompt to resolve conflicts that can be resolved with human input. For example, if you remove an attribute and add an attribute, it will ask you if you are renaming the column in question. If not, it will remove one column and add the other.Additionally, it lowers things to the database where possible:DefaultsThere are three anonymous functions that will translate to database-specific defaults currently:&amp;Ash.uuid/0 - Only if uuid-ossp is in your c:AshPostgres.Repo.installed_extensions()&amp;Ecto.UUID.generate/0 - Only if uuid-ossp is in your c:AshPostgres.Repo.installed_extensions()&amp;DateTime.utc_now/0Non-function default values will be dumped to their native type and inspected. This may not work for some types, and may require manual intervention/patches to the migration generator code.IdentitiesIdentities will cause the migration generator to generate unique constraints. If multiple resources target the same table, you will be asked to select the primary key, and any others will be added as unique constraints.","ref":"Mix.Tasks.AshPostgres.GenerateMigrations.html","title":"Mix.Tasks.AshPostgres.GenerateMigrations","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1.","ref":"Mix.Tasks.AshPostgres.GenerateMigrations.html#run/1","title":"Mix.Tasks.AshPostgres.GenerateMigrations.run/1","type":"function"},{"doc":"A postgres extension library for Ash.AshPostgres.DataLayer provides a DataLayer, and a DSL extension to configure that data layer.The dsl extension exposes the postgres section. See: AshPostgres.DataLayer.postgres/1 for more.","ref":"AshPostgres.html","title":"AshPostgres","type":"module"},{"doc":"A stringified version of the base_filter, to be used in a where clause when generating unique indexes","ref":"AshPostgres.html#base_filter_sql/1","title":"AshPostgres.base_filter_sql/1","type":"function"},{"doc":"Whether or not the resource should be included when generating migrations","ref":"AshPostgres.html#migrate?/1","title":"AshPostgres.migrate?/1","type":"function"},{"doc":"The configured repo for a resource","ref":"AshPostgres.html#repo/1","title":"AshPostgres.repo/1","type":"function"},{"doc":"Skip generating unique indexes when generating migrations","ref":"AshPostgres.html#skip_unique_indexes?/1","title":"AshPostgres.skip_unique_indexes?/1","type":"function"},{"doc":"The configured table for a resource","ref":"AshPostgres.html#table/1","title":"AshPostgres.table/1","type":"function"},{"doc":"A postgres data layer that levereges Ecto's postgres capabilities.AshPostgres supports all capabilities of an Ash data layer, and it will most likely stay that way, as postgres is the primary target/most maintained data layer.Custom Predicates:AshPostgres.Predicates.TrigramUsage First, ensure you've added ash_postgres to your mix.exs file.{:ash_postgres, &quot;~&gt; x.y.z&quot;}To use this data layer, you need to define an Ecto.Repo. AshPostgres adds some functionality on top of ecto repos, so you'll want to use AshPostgres.RepoThen, configure your resource like so:postgres do repo MyApp.Repo table &quot;table_name&quot; endGenerating MigrationsSee the documentation for Mix.Tasks.AshPostgres.GenerateMigrations for how to generate migrations from your resources","ref":"AshPostgres.DataLayer.html","title":"AshPostgres.DataLayer","type":"module"},{"doc":"Postgres data layer configurationOptions:repo - Required. The repo that will be used to fetch your data. See the AshPostgres.Repo documentation for more:migrate? - Whether or not to include this resource in the generated migrations with mix ash.generate_migrations The default value is true.:base_filter_sql - A raw sql version of the base_filter, e.g representative = true. Required if trying to create a unique constraint on a resource with a base_filter:skip_unique_indexes - Skip generating unique indexes when generating migrations The default value is false.:table - Required. The table to store and read the resource from","ref":"AshPostgres.DataLayer.html#postgres/1","title":"AshPostgres.DataLayer.postgres/1","type":"macro"},{"doc":"Resources that use the AshPostgres data layer use a Repo to access the database.This repo is a slightly modified version of an Ecto.Repo.You can use Ecto.Repo's init/2 to configure your repo like normal, but instead of returning {:ok, config}, use super(config) to pass the configuration to the AshPostgres.Repo implementation.Currently the only additional configuration supported is installed_extensions, and the only extension that ash_postgres reacts to is &quot;pg_trgm&quot;. If this extension is installed, then the AshPostgres.Predicates.Trigram custom predicate will be available.def installed_extensions() do [&quot;pg_trgm&quot;] end","ref":"AshPostgres.Repo.html","title":"AshPostgres.Repo","type":"behaviour"},{"doc":"Use this to inform the data layer about what extensions are installed","ref":"AshPostgres.Repo.html#c:installed_extensions/0","title":"AshPostgres.Repo.installed_extensions/0","type":"callback"},{"doc":"Generates migrations based on resource snapshotsSee Mix.Tasks.AshPostgres.GenerateMigrations for more information.","ref":"AshPostgres.MigrationGenerator.html","title":"AshPostgres.MigrationGenerator","type":"module"},{"doc":"","ref":"AshPostgres.MigrationGenerator.html#attributes/1","title":"AshPostgres.MigrationGenerator.attributes/1","type":"function"},{"doc":"","ref":"AshPostgres.MigrationGenerator.html#generate/2","title":"AshPostgres.MigrationGenerator.generate/2","type":"function"},{"doc":"","ref":"AshPostgres.MigrationGenerator.html#get_existing_snapshot/2","title":"AshPostgres.MigrationGenerator.get_existing_snapshot/2","type":"function"},{"doc":"","ref":"AshPostgres.MigrationGenerator.html#get_snapshot/1","title":"AshPostgres.MigrationGenerator.get_snapshot/1","type":"function"},{"doc":"A filter predicate that filters based on trigram similarity.See the postgres docs on https://www.postgresql.org/docs/9.6/pgtrgm.html for more information.Requires the pg_trgm extension. Configure which extensions you have installed in your AshPostgres.Repo# Example filter(query, name: [trigram: [text: &quot;geoff&quot;, greater_than: 0.4]])","ref":"AshPostgres.Predicates.Trigram.html","title":"AshPostgres.Predicates.Trigram","type":"module"},{"doc":"Callback implementation for Ash.Filter.Predicate.new/3.","ref":"AshPostgres.Predicates.Trigram.html#new/3","title":"AshPostgres.Predicates.Trigram.new/3","type":"function"}]